#ifndef SamiApi_H_
#define SamiApi_H_

#include <FNet.h>
#include "SamiApiClient.h"
#include "SamiError.h"

using Tizen::Base::Long;
using Tizen::Base::String;
#include "SamiObject.h"
using Tizen::Base::Integer;

using namespace Tizen::Net::Http;

namespace Swagger {

class SamiApi {
public:
  SamiApi();
  virtual ~SamiApi();

  
  Long* 
  balanceGetWithCompletion(String* token, void (* handler)(Long*, SamiError*));
  
  Long* 
  balanceLicGetWithCompletion(String* token, void (* handler)(Long*, SamiError*));
  
  IList* 
  billingDebtGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  IList* 
  billingInfoGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  SamiObject* 
  billingLimitsGetWithCompletion(String* token, void (* handler)(SamiObject*, SamiError*));
  
  IList* 
  dnsProlongListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  String* 
  emailAddGetWithCompletion(String* token, String* addEmail, void (* handler)(String*, SamiError*));
  
  String* 
  emailAliasDeleteGetWithCompletion(String* token, String* key, void (* handler)(String*, SamiError*));
  
  IList* 
  emailAliasListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  String* 
  emailDeleteGetWithCompletion(String* token, String* key, void (* handler)(String*, SamiError*));
  
  IList* 
  emailListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  Integer* 
  updatesLastGetWithCompletion(String* token, void (* handler)(Integer*, SamiError*));
  
  IList* 
  updatesListGetWithCompletion(String* token, Integer* key, void (* handler)(IList*, SamiError*));
  
  String* 
  websiteDeleteGetWithCompletion(String* token, String* key, void (* handler)(String*, SamiError*));
  
  IList* 
  websiteListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  static String getBasePath() {
    return L"https://www.1gb.ru/api";
  }

private:
  SamiApiClient* client;
};


} /* namespace Swagger */

#endif /* SamiApi_H_ */
