#ifndef SamiDNSApi_H_
#define SamiDNSApi_H_

#include <FNet.h>
#include "SamiApiClient.h"
#include "SamiError.h"

using Tizen::Base::String;
using Tizen::Base::Boolean;
using Tizen::Base::Integer;
#include "SamiObject.h"

using namespace Tizen::Net::Http;

namespace Swagger {

class SamiDNSApi {
public:
  SamiDNSApi();
  virtual ~SamiDNSApi();

  
  String* 
  dnsAddGetWithCompletion(String* token, String* addDnsZone, String* addDnsRecord, String* iisSiteForDns, Boolean* bindOnly, void (* handler)(String*, SamiError*));
  
  String* 
  dnsBindGetWithCompletion(String* token, Integer* key, String* bindTo, void (* handler)(String*, SamiError*));
  
  IList* 
  dnsListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  IList* 
  dnsProlongListGetWithCompletion(String* token, void (* handler)(IList*, SamiError*));
  
  String* 
  dnsRawGetWithCompletion(String* token, Integer* key, Integer* sDel, Integer* sAdd, String* dnsType, String* dnsName, String* dnsValue, void (* handler)(String*, SamiError*));
  
  String* 
  dnsRawManagedmxGetWithCompletion(String* token, Integer* key, Integer* managedMx, Integer* updManagedMx, void (* handler)(String*, SamiError*));
  
  static String getBasePath() {
    return L"https://www.1gb.ru/api";
  }

private:
  SamiApiClient* client;
};


} /* namespace Swagger */

#endif /* SamiDNSApi_H_ */
